package aiOR_Support {

//---------------------------------------------------------------------------

function DefaultGame::testTurretKill(%game, %implement)
{
   if (isObject(%implement)) //added to fix deployable turret spam - Lagg...
   {
       if(%implement == 0)
          return false;
       else     
          return (%implement.getClassName() $= "Turret");
   }
}

//-------------------------------------------------------------------------------------------
//spamerror fix ---------------------------------------------------

function stopRepairing(%player)
{
   if (!isObject(%player))
   {
      //echo("fixed consol error 'stop repairing'");
      return;
   }
   // %player = the player who was using the repair pack

   if(%player.selfRepairing)
   {
      // there is no projectile for self-repairing
      %player.setRepairRate(%player.getRepairRate() - %player.repairingRate);
      %player.selfRepairing = false;
   }
   else if(%player.repairing > 0)
   {
      // player was repairing something else
      //if(%player.repairing.beingRepaired > 0)
      //{
         // don't decrement this stuff if it's already at 0 -- though it shouldn't be
         //%player.repairing.beingRepaired--;
         %player.repairing.setRepairRate(%player.repairing.getRepairRate() - %player.repairingRate);
      //}
      if(%player.repairProjectile > 0)
      {
         // is there a repair projectile? delete it
         %player.repairProjectile.delete();
         %player.repairProjectile = 0;
      }
   }
   %player.repairing = 0;
   %player.repairingRate = 0;
   %player.setImageTrigger($WeaponSlot, false);
   %player.setImageLoaded($WeaponSlot, false);
}
//-------------------------------------------------------------------------------
};
